> ## Documentation Index
> Fetch the complete documentation index at: https://gcore.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Retrieve custom page sets available for use

> Retrieve a list of custom page sets available for use



## OpenAPI

````yaml /api-reference/services_documented/waap_api.yaml get /waap/v1/custom-page-sets
openapi: 3.1.0
info:
  title: Gcore OpenAPI – WAAP API
  description: >-
    This OpenAPI is an aggregated OpenAPI specification that unifies all Gcore
    products into a single file. It covers Cloud, CDN, DNS, WAAP, DDoS
    Protection, Object Storage, Streaming, and FastEdge services.
  version: '2026-05-14T07:00:22.640261+00:00'
servers:
  - url: https://api.gcore.com
security:
  - APIKey: []
tags:
  - name: WAAP Service
    x-displayName: WAAP Service
  - name: Domains
    x-displayName: Domains
  - name: Policies
    x-displayName: Policies
  - name: Analytics
    x-displayName: Analytics
  - name: Custom Page Sets
    x-displayName: Custom Page Sets
  - name: Custom Rules
    x-displayName: Custom Rules
  - name: Filter Templates
    x-displayName: Filter Templates
  - name: Firewall Rules
    x-displayName: Firewall Rules
  - name: Advanced Rules
    x-displayName: Advanced Rules
  - name: Tags
    x-displayName: Tags
  - name: Network Organizations
    x-displayName: Network Organizations
  - name: API Discovery
    x-displayName: API Discovery
  - name: IP Spotlight
    x-displayName: IP Spotlight
  - name: Security Insights
    x-displayName: Security Insights
  - name: IP Reputation
    x-displayName: IP Reputation
paths:
  /waap/v1/custom-page-sets:
    get:
      tags:
        - Custom Page Sets
      summary: Retrieve custom page sets available for use
      description: Retrieve a list of custom page sets available for use
      operationId: get_custom_page_sets_v1_custom_page_sets_get
      parameters:
        - name: ordering
          in: query
          required: false
          schema:
            enum:
              - name
              - '-name'
              - id
              - '-id'
            type: string
            description: Sort the response by given field.
            title: Ordering
          description: Sort the response by given field.
        - name: limit
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 0
            description: Number of items to return
            default: 100
            title: Limit
          description: Number of items to return
        - name: offset
          in: query
          required: false
          schema:
            type: integer
            maximum: 100000
            minimum: 0
            description: Number of items to skip
            default: 0
            title: Offset
          description: Number of items to skip
        - name: name
          in: query
          required: false
          schema:
            type: string
            description: >-
              Filter page sets based on their name. Supports '*' as a wildcard
              character
            example: '*example'
            examples:
              - '*example'
            title: Name
          description: >-
            Filter page sets based on their name. Supports '*' as a wildcard
            character
        - name: ids
          in: query
          required: false
          schema:
            type: array
            items:
              type: integer
            description: Filter page sets based on their IDs
            title: Ids
          description: Filter page sets based on their IDs
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/PaginatedResponse_CustomPageSetResponse_'
        '400':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-bad-request
                title: Bad Request
                status: 400
                detail: 'Invalid domain name: '''''''''
          description: Bad Request
        '401':
          description: Unauthorized
          content:
            application/problem+json:
              example:
                detail: Auth token is missing or invalid
        '403':
          description: Unauthenticated
          content:
            application/problem+json:
              example:
                detail: Permission denied
        '404':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: http-not-found
                title: Not Found
                status: 404
                detail: The resource is not found
          description: Not Found
        '422':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APICompositeError'
              example:
                type: request-validation-failed
                title: Request validation error.
                status: 422
                detail: One or more fields have validation errors.
                errors:
                  - loc:
                      - body
                      - name
                    detail: Input should be a valid string
                  - loc:
                      - body
                      - date
                    detail: Field required
                  - loc:
                      - query
                      - limit
                    detail: Field required
          description: Unprocessable Entity
        '500':
          content:
            application/problem+json:
              schema:
                $ref: '#/components/schemas/APIError'
              example:
                type: internal-server-error
                title: Internal server error.
                status: 500
                detail: >-
                  An unexpected condition was encountered which prevented the
                  server from fulfilling the request.
          description: Internal Server Error
      x-codeSamples:
        - lang: Python
          source: |-
            import os
            from gcore import Gcore

            client = Gcore(
                api_key=os.environ.get("GCORE_API_KEY"),  # This is the default and can be omitted
            )
            page = client.waap.custom_page_sets.list()
            page = page.results[0]
            print(page.id)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/G-Core/gcore-go\"\n\t\"github.com/G-Core/gcore-go/option\"\n\t\"github.com/G-Core/gcore-go/waap\"\n)\n\nfunc main() {\n\tclient := gcore.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.Waap.CustomPageSets.List(context.TODO(), waap.CustomPageSetListParams{})\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
components:
  schemas:
    PaginatedResponse_CustomPageSetResponse_:
      properties:
        limit:
          type: integer
          title: Limit
          description: Number of items requested in the response
        offset:
          type: integer
          title: Offset
          description: Items response offset used
        count:
          type: integer
          title: Count
          description: Number of items contain in the response
        results:
          items:
            $ref: '#/components/schemas/CustomPageSetResponse'
          type: array
          title: Results
          description: List of items returned in the response following given criteria
      type: object
      required:
        - limit
        - offset
        - count
        - results
      title: PaginatedResponse[CustomPageSetResponse]
    APIError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
      type: object
      required:
        - type
        - title
        - status
        - detail
      title: APIError
    APICompositeError:
      properties:
        type:
          type: string
          title: Type
          description: A URI identifier that categorizes the type of error.
        title:
          type: string
          title: Title
          description: A brief, human-readable title for the error.
        status:
          type: integer
          title: Status
          description: The HTTP status code applicable to this error.
        detail:
          anyOf:
            - type: string
            - type: 'null'
          title: Detail
          description: A detailed human-readable explanation of the error.
        errors:
          items:
            $ref: '#/components/schemas/APIFieldError'
          type: array
          title: Errors
          description: A list of detailed errors for individual fields.
      type: object
      required:
        - type
        - title
        - status
        - detail
        - errors
      title: APICompositeError
    CustomPageSetResponse:
      properties:
        domains:
          anyOf:
            - items:
                type: integer
                exclusiveMinimum: 0
                description: The domain ID
              type: array
            - type: 'null'
          title: Domains
          description: List of domain IDs that are associated with this page set
        block:
          anyOf:
            - $ref: '#/components/schemas/BlockPageData'
            - type: 'null'
        block_csrf:
          anyOf:
            - $ref: '#/components/schemas/BlockCsrfPageData'
            - type: 'null'
        captcha:
          anyOf:
            - $ref: '#/components/schemas/CaptchaPageData'
            - type: 'null'
        cookie_disabled:
          anyOf:
            - $ref: '#/components/schemas/CookieDisabledPageData'
            - type: 'null'
        handshake:
          anyOf:
            - $ref: '#/components/schemas/HandshakePageData'
            - type: 'null'
        javascript_disabled:
          anyOf:
            - $ref: '#/components/schemas/JavascriptDisabledPageData'
            - type: 'null'
        name:
          type: string
          maxLength: 50
          minLength: 1
          title: Name
          description: Name of the custom page set
        id:
          type: integer
          title: Id
          description: The ID of the custom page set
      additionalProperties: false
      type: object
      required:
        - name
        - id
      title: CustomPageSetResponse
    APIFieldError:
      properties:
        loc:
          anyOf:
            - items:
                anyOf:
                  - type: integer
                  - type: string
              type: array
            - {}
          title: Loc
          description: The location of the field or a character number causing the error.
        detail:
          type: string
          title: Detail
          description: A human-readable message describing the error.
      type: object
      required:
        - loc
        - detail
      title: APIFieldError
    BlockPageData:
      properties:
        logo:
          type: string
          title: A base64 encoded image of the logo to present
          description: >-
            Supported image types are JPEG, PNG and JPG, size is limited to
            width 450px, height 130px. This should be a base 64 encoding of the
            full HTML img tag compatible image, with the header included.
        header:
          type: string
          maxLength: 62
          minLength: 3
          title: Header
          description: The text to display in the header of the custom page
        title:
          type: string
          maxLength: 50
          minLength: 3
          title: Title
          description: The text to display in the title of the custom page
        text:
          type: string
          maxLength: 400
          minLength: 20
          title: Text
          description: The text to display in the body of the custom page
        enabled:
          type: boolean
          title: Enabled
          description: Indicates whether the custom custom page is active or inactive
      type: object
      required:
        - enabled
      title: BlockPageData
    BlockCsrfPageData:
      properties:
        logo:
          type: string
          title: A base64 encoded image of the logo to present
          description: >-
            Supported image types are JPEG, PNG and JPG, size is limited to
            width 450px, height 130px. This should be a base 64 encoding of the
            full HTML img tag compatible image, with the header included.
        header:
          type: string
          maxLength: 62
          minLength: 3
          title: Header
          description: The text to display in the header of the custom page
        title:
          type: string
          maxLength: 50
          minLength: 3
          title: Title
          description: The text to display in the title of the custom page
        text:
          type: string
          maxLength: 400
          minLength: 20
          title: Text
          description: The text to display in the body of the custom page
        enabled:
          type: boolean
          title: Enabled
          description: Indicates whether the custom custom page is active or inactive
      type: object
      required:
        - enabled
      title: BlockCsrfPageData
    CaptchaPageData:
      properties:
        logo:
          type: string
          title: A base64 encoded image of the logo to present
          description: >-
            Supported image types are JPEG, PNG and JPG, size is limited to
            width 450px, height 130px. This should be a base 64 encoding of the
            full HTML img tag compatible image, with the header included.
        header:
          type: string
          maxLength: 62
          minLength: 3
          title: Header
          description: The text to display in the header of the custom page
        title:
          type: string
          maxLength: 50
          minLength: 3
          title: Title
          description: The text to display in the title of the custom page
        text:
          type: string
          maxLength: 400
          minLength: 20
          title: Text
          description: The text to display in the body of the custom page
        error:
          type: string
          maxLength: 400
          minLength: 10
          title: Error
          description: Error message
        enabled:
          type: boolean
          title: Enabled
          description: Indicates whether the custom custom page is active or inactive
      type: object
      required:
        - enabled
      title: CaptchaPageData
    CookieDisabledPageData:
      properties:
        header:
          type: string
          maxLength: 62
          minLength: 3
          title: Header
          description: The text to display in the header of the custom page
        text:
          type: string
          maxLength: 400
          minLength: 20
          title: Text
          description: The text to display in the body of the custom page
        enabled:
          type: boolean
          title: Enabled
          description: Indicates whether the custom custom page is active or inactive
      type: object
      required:
        - enabled
      title: CookieDisabledPageData
    HandshakePageData:
      properties:
        logo:
          type: string
          title: A base64 encoded image of the logo to present
          description: >-
            Supported image types are JPEG, PNG and JPG, size is limited to
            width 450px, height 130px. This should be a base 64 encoding of the
            full HTML img tag compatible image, with the header included.
        header:
          type: string
          maxLength: 62
          minLength: 3
          title: Header
          description: The text to display in the header of the custom page
        title:
          type: string
          maxLength: 50
          minLength: 3
          title: Title
          description: The text to display in the title of the custom page
        enabled:
          type: boolean
          title: Enabled
          description: Indicates whether the custom custom page is active or inactive
      type: object
      required:
        - enabled
      title: HandshakePageData
    JavascriptDisabledPageData:
      properties:
        header:
          type: string
          maxLength: 62
          minLength: 3
          title: Header
          description: The text to display in the header of the custom page
        text:
          type: string
          maxLength: 400
          minLength: 20
          title: Text
          description: The text to display in the body of the custom page
        enabled:
          type: boolean
          title: Enabled
          description: Indicates whether the custom custom page is active or inactive
      type: object
      required:
        - enabled
      title: JavascriptDisabledPageData
  securitySchemes:
    APIKey:
      description: >-
        API key for authentication. Make sure to include the word `apikey`,
        followed by a single space and then your token.

        Example: `apikey 1234$abcdef`
      type: apiKey
      in: header
      name: Authorization

````